Index: /trunk/include/ws_functions/pwg.users.php
===================================================================
--- /trunk/include/ws_functions/pwg.users.php	(revision 25281)
+++ /trunk/include/ws_functions/pwg.users.php	(revision 25281)
@@ -0,0 +1,446 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2013 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+/**
+ * API method
+ * Returns a list of users
+ * @param mixed[] $params
+ *    @option int[] user_id (optional)
+ *    @option string username (optional)
+ *    @option string[] status (optional)
+ *    @option int min_level (optional)
+ *    @option int[] group_id (optional)
+ *    @option int per_page
+ *    @option int page
+ *    @option string order
+ */
+function ws_users_getList($params, &$service)
+{
+  global $conf;
+
+  $where_clauses = array('1=1');
+
+  if (!empty($params['user_id']))
+  {
+    $where_clauses[] = 'u.'.$conf['user_fields']['id'].' IN('. implode(',', $params['user_id']) .')';
+  }
+
+  if (!empty($params['username']))
+  {
+    $where_clauses[] = 'u.'.$conf['user_fields']['username'].' LIKE \''.pwg_db_real_escape_string($params['username']).'\'';
+  }
+
+  if (!empty($params['status']))
+  {
+    $params['status'] = array_intersect($params['status'], get_enums(USER_INFOS_TABLE, 'status'));
+    if (count($params['status']) > 0)
+    {
+      $where_clauses[] = 'ui.status IN("'. implode('","', $params['status']) .'")';
+    }
+  }
+
+  if (!empty($params['min_level']))
+  {
+    if ( !in_array($params['min_level'], $conf['available_permission_levels']) )
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, 'Invalid level');
+    }
+    $where_clauses[] = 'ui.level >= '.$params['min_level'];
+  }
+
+  if (!empty($params['group_id']))
+  {
+    $where_clauses[] = 'ug.group_id IN('. implode(',', $params['group_id']) .')';
+  }
+
+  $display = array('u.'.$conf['user_fields']['id'] => 'id');
+
+  if ($params['display'] != 'none')
+  {
+    $params['display'] = explode(',', $params['display']);
+
+    if (in_array('all', $params['display']))
+    {
+      $params['display'] = array_merge($params['display'], array(
+        'username','email','status','level','groups','language','theme',
+        'nb_image_page','recent_period','expand','show_nb_comments','show_nb_hits',
+        'enabled_high',
+        ));
+    }
+    else if (in_array('basics', $params['display']))
+    {
+      $params['display'] = array_merge($params['display'], array(
+        'username','email','status','level','groups',
+        ));
+    }
+
+    if (in_array('username', $params['display']))
+    {
+      $display['u.'.$conf['user_fields']['username']] = 'username';
+    }
+    if (in_array('email', $params['display']))
+    {
+      $display['u.'.$conf['user_fields']['email']] = 'email';
+    }
+
+    $ui_fields = array(
+      'status','level','language','theme','nb_image_page','recent_period','expand',
+      'show_nb_comments','show_nb_hits','enabled_high',
+      );
+    foreach ($ui_fields as $field)
+    {
+      if (in_array($field, $params['display']))
+      {
+        $display['ui.'.$field] = $field;
+      }
+    }
+  }
+  else
+  {
+    $params['display'] = array();
+  }
+
+  $query = '
+SELECT DISTINCT ';
+
+  $first = true;
+  foreach ($display as $field => $name)
+  {
+    if (!$first) $query.= ', ';
+    else $first = false;
+    $query.= $field .' AS '. $name;
+  }
+  if (in_array('groups', $params['display']))
+  {
+    if (!$first) $query.= ', ';
+    $query.= '"" AS groups';
+  }
+
+  $query.= '
+  FROM '. USERS_TABLE .' AS u
+    INNER JOIN '. USER_INFOS_TABLE .' AS ui
+      ON u.'. $conf['user_fields']['id'] .' = ui.user_id
+    LEFT JOIN '. USER_GROUP_TABLE .' AS ug
+      ON u.'. $conf['user_fields']['id'] .' = ug.user_id
+  WHERE
+    '. implode(' AND ', $where_clauses) .'
+  ORDER BY '. $params['order'] .'
+  LIMIT '. $params['per_page'] .'
+  OFFSET '. ($params['per_page']*$params['page']) .'
+;';
+
+  $users = hash_from_query($query, 'id');
+
+  if (count($users) > 0 and in_array('groups', $params['display']))
+  {
+    $query = '
+SELECT user_id, group_id
+  FROM '. USER_GROUP_TABLE .'
+  WHERE user_id IN ('. implode(',', array_keys($users)) .')
+;';
+    $result = pwg_query($query);
+
+    while ($row = pwg_db_fetch_assoc($result))
+    {
+      $users[ $row['user_id'] ]['groups'][] = $row['group_id'];
+    }
+  }
+
+  return array(
+    'paging' => new PwgNamedStruct(
+      array(
+        'page' => $params['page'],
+        'per_page' => $params['per_page'],
+        'count' => count($users)
+        )
+      ),
+    'users' => new PwgNamedArray(array_values($users), 'user')
+    );
+}
+
+/**
+ * API method
+ * Adds a user
+ * @param mixed[] $params
+ *    @option string username
+ *    @option string password (optional)
+ *    @option string email (optional)
+ */
+function ws_users_add($params, &$service)
+{
+  global $conf;
+
+  if ($conf['double_password_type_in_admin'])
+  {
+    if ($params['password'] != $params['password_confirm'])
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, l10n('The passwords do not match'));
+    }
+  }
+
+  $user_id = register_user(
+    $params['username'],
+    $params['password'],
+    $params['email'],
+    false, // notify admin
+    $errors,
+    $params['send_password_by_mail']
+    );
+
+  if (!$user_id)
+  {
+    return new PwgError(WS_ERR_INVALID_PARAM, $errors[0]);
+  }
+
+  return $service->invoke('pwg.users.getList', array('user_id'=>$user_id));
+}
+
+/**
+ * API method
+ * Deletes users
+ * @param mixed[] $params
+ *    @option int[] user_id
+ *    @option string pwg_token
+ */
+function ws_users_delete($params, &$service)
+{
+  if (get_pwg_token() != $params['pwg_token'])
+  {
+    return new PwgError(403, 'Invalid security token');
+  }
+
+  global $conf, $user;
+
+  include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+
+  // protect some users
+  $params['user_id'] = array_diff(
+    $params['user_id'],
+    array(
+      $user['id'],
+      $conf['guest_id'],
+      $conf['default_user_id'],
+      $conf['webmaster_id'],
+      )
+    );
+
+  foreach ($params['user_id'] as $user_id)
+  {
+    delete_user($user_id);
+  }
+
+  return l10n_dec(
+        '%d user deleted', '%d users deleted',
+        count($params['user_id'])
+        );
+}
+
+/**
+ * API method
+ * Updates users
+ * @param mixed[] $params
+ *    @option int[] user_id
+ *    @option string username (optional)
+ *    @option string password (optional)
+ *    @option string email (optional)
+ *    @option string status (optional)
+ *    @option int level (optional)
+ *    @option string language (optional)
+ *    @option string theme (optional)
+ *    @option int nb_image_page (optional)
+ *    @option int recent_period (optional)
+ *    @option bool expand (optional)
+ *    @option bool show_nb_comments (optional)
+ *    @option bool show_nb_hits (optional)
+ *    @option bool enabled_high (optional)
+ */
+function ws_users_setInfo($params, &$service)
+{
+  global $conf, $user;
+
+  include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+
+  $updates = $updates_infos = array();
+  $update_status = null;
+
+  if (count($params['user_id']) == 1)
+  {
+    if (get_username($params['user_id'][0]) === false)
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, 'This user does not exist.');
+    }
+
+    if (!empty($params['username']))
+    {
+      $user_id = get_userid($params['username']);
+      if ($user_id and $user_id != $params['user_id'][0])
+      {
+        return new PwgError(WS_ERR_INVALID_PARAM, l10n('this login is already used'));
+      }
+      if ($params['username'] != strip_tags($params['username']))
+      {
+        return new PwgError(WS_ERR_INVALID_PARAM, l10n('html tags are not allowed in login'));
+      }
+      $updates[ $conf['user_fields']['username'] ] = $params['username'];
+    }
+
+    if (!empty($params['email']))
+    {
+      if ( ($error = validate_mail_address($params['user_id'][0], $params['email'])) != '')
+      {
+        return new PwgError(WS_ERR_INVALID_PARAM, $error);
+      }
+      $updates[ $conf['user_fields']['email'] ] = $params['email'];
+    }
+
+    if (!empty($params['password']))
+    {
+      $updates[ $conf['user_fields']['password'] ] = $conf['password_hash']($params['password']);
+    }
+  }
+
+  if (!empty($params['status']))
+  {
+    if ( $params['status'] == 'webmaster' and !is_webmaster() )
+    {
+      return new PwgError(403, 'Only webmasters can grant "webmaster" status');
+    }
+    if ( !in_array($params['status'], array('guest','generic','normal','admin','webmaster')) )
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, 'Invalid status');
+    }
+
+    // status update query is separated from the rest as not applying to the same
+    // set of users (current, guest and webmaster can't be changed)
+    $params['user_id_for_status'] = array_diff(
+      $params['user_id'],
+      array(
+        $user['id'],
+        $conf['guest_id'],
+        $conf['webmaster_id'],
+        )
+      );
+
+    $update_status = $params['status'];
+  }
+
+  if (!empty($params['level']) or @$params['level']===0)
+  {
+    if ( !in_array($params['level'], $conf['available_permission_levels']) )
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, 'Invalid level');
+    }
+    $updates_infos['level'] = $params['level'];
+  }
+
+  if (!empty($params['language']))
+  {
+    if ( !in_array($params['language'], array_keys(get_languages())) )
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, 'Invalid language');
+    }
+    $updates_infos['language'] = $params['language'];
+  }
+
+  if (!empty($params['theme']))
+  {
+    if ( !in_array($params['theme'], array_keys(get_pwg_themes())) )
+    {
+      return new PwgError(WS_ERR_INVALID_PARAM, 'Invalid theme');
+    }
+    $updates_infos['theme'] = $params['theme'];
+  }
+
+  if (!empty($params['nb_image_page']))
+  {
+    $updates_infos['nb_image_page'] = $params['nb_image_page'];
+  }
+
+  if (!empty($params['recent_period']) or @$params['recent_period']===0)
+  {
+    $updates_infos['recent_period'] = $params['recent_period'];
+  }
+
+  if (!empty($params['expand']) or @$params['expand']===false)
+  {
+    $updates_infos['expand'] = boolean_to_string($params['expand']);
+  }
+
+  if (!empty($params['show_nb_comments']) or @$params['show_nb_comments']===false)
+  {
+    $updates_infos['show_nb_comments'] = boolean_to_string($params['show_nb_comments']);
+  }
+
+  if (!empty($params['show_nb_hits']) or @$params['show_nb_hits']===false)
+  {
+    $updates_infos['show_nb_hits'] = boolean_to_string($params['show_nb_hits']);
+  }
+
+  if (!empty($params['enabled_high']) or @$params['enabled_high']===false)
+  {
+    $updates_infos['enabled_high'] = boolean_to_string($params['enabled_high']);
+  }
+
+  // perform updates
+  single_update(
+    USERS_TABLE,
+    $updates,
+    array($conf['user_fields']['id'] => $params['user_id'][0])
+    );
+
+  if (isset($update_status) and count($params['user_id_for_status']) > 0)
+  {
+    $query = '
+UPDATE '. USER_INFOS_TABLE .' SET
+    status = "'. $update_status .'"
+  WHERE user_id IN('. implode(',', $params['user_id_for_status']) .')
+;';
+    pwg_query($query);
+  }
+
+  if (count($updates_infos) > 0)
+  {
+    $query = '
+UPDATE '. USER_INFOS_TABLE .' SET ';
+
+    $first = true;
+    foreach ($updates_infos as $field => $value)
+    {
+      if (!$first) $query.= ', ';
+      else $first = false;
+      $query.= $field .' = "'. $value .'"';
+    }
+
+    $query.= '
+  WHERE user_id IN('. implode(',', $params['user_id']) .')
+;';
+    pwg_query($query);
+  }
+
+  return $service->invoke('pwg.users.getList', array(
+    'user_id' => $params['user_id'],
+    'display' => 'basics,'.implode(',', array_keys($updates_infos)),
+    ));
+}
+
+?>
Index: /trunk/ws.php
===================================================================
--- /trunk/ws.php	(revision 25280)
+++ /trunk/ws.php	(revision 25281)
@@ -26,5 +26,4 @@
 include_once(PHPWG_ROOT_PATH.'include/common.inc.php');
 check_status(ACCESS_FREE);
-include_once(PHPWG_ROOT_PATH.'include/ws_core.inc.php');
 
 if ( !$conf['allow_web_services'] )
@@ -33,6 +32,7 @@
 }
 
+include_once(PHPWG_ROOT_PATH.'include/ws_core.inc.php');
+
 add_event_handler('ws_add_methods', 'ws_addDefaultMethods');
-
 add_event_handler('ws_invoke_allowed', 'ws_isInvokeAllowed', EVENT_HANDLER_PRIORITY_NEUTRAL, 3);
 
@@ -103,4 +103,5 @@
   
   include_once(PHPWG_ROOT_PATH.'include/ws_functions.inc.php');
+  $ws_functions_root = PHPWG_ROOT_PATH.'include/ws_functions/';
   
   $f_params = array(
@@ -129,5 +130,6 @@
       'ws_getVersion',
       null,
-      'Returns the Piwigo version.'
+      'Returns the Piwigo version.',
+      $ws_functions_root . 'pwg.php'
     );
 	  
@@ -137,5 +139,5 @@
       null,
       '<b>Admin only.</b> Returns general informations.',
-      null,
+      $ws_functions_root . 'pwg.php',
       array('admin_only'=>true)
     );
@@ -149,5 +151,5 @@
         ),
       '<b>Admin only.</b> Adds elements to the caddie. Returns the number of elements added.',
-      null,
+      $ws_functions_root . 'pwg.php',
       array('admin_only'=>true)
     );
@@ -172,5 +174,6 @@
       'Returns elements for the corresponding categories.
 <br><b>cat_id</b> can be empty if <b>recursive</b> is true.
-<br><b>order</b> comma separated fields for sorting'
+<br><b>order</b> comma separated fields for sorting',
+      $ws_functions_root . 'pwg.categories.php'
     );
 
@@ -191,5 +194,6 @@
                                 'type'=>WS_TYPE_BOOL),
         ),
-      'Returns a list of categories.'
+      'Returns a list of categories.',
+      $ws_functions_root . 'pwg.categories.php'
     );
 
@@ -210,5 +214,5 @@
         ), $f_params),
       '<b>Admin only.</b> Returns a list of derivatives to build.',
-      null,
+      $ws_functions_root . 'pwg.php',
       array('admin_only'=>true)
     );
@@ -224,5 +228,5 @@
         ),
       '<b>POST only.</b> Adds a comment to an image.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('post_only'=>true)
     );
@@ -239,5 +243,6 @@
                                       'type'=>WS_TYPE_INT|WS_TYPE_POSITIVE),
         ),
-      'Returns information about an image.'
+      'Returns information about an image.',
+      $ws_functions_root . 'pwg.images.php'
     );
 
@@ -249,5 +254,6 @@
         'rate' =>     array('type'=>WS_TYPE_FLOAT),
       ),
-      'Rates an image.'
+      'Rates an image.',
+      $ws_functions_root . 'pwg.images.php'
     );
 
@@ -265,5 +271,6 @@
                                 'info'=>'id, file, name, hit, rating_score, date_creation, date_available, random'),
         ), $f_params),
-      'Returns elements for the corresponding query search.'
+      'Returns elements for the corresponding query search.',
+      $ws_functions_root . 'pwg.images.php'
     );
 
@@ -278,5 +285,5 @@
         ),
       '<b>Admin & POST only.</b> Sets the privacy levels for the images.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -291,5 +298,5 @@
         ),
       '<b>Admin & POST only.</b> Sets the rank of a photo for a given album.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -303,5 +310,5 @@
         ),
       '<b>Admin & POST only.</b> Deletes all rates for a user.',
-      null,
+      $ws_functions_root . 'pwg.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -311,5 +318,6 @@
       'ws_session_getStatus',
       null,
-      'Gets information about the current session. Also provides a token useable with admin methods.'
+      'Gets information about the current session. Also provides a token useable with admin methods.',
+      $ws_functions_root . 'pwg.php'
     );
 
@@ -319,5 +327,5 @@
       array('username', 'password'),
       '<b>POST only.</b> Tries to login the user.',
-      null,
+      $ws_functions_root . 'pwg.php',
       array('post_only'=>true)
     );
@@ -327,5 +335,6 @@
       'ws_session_logout',
       null,
-      'Ends the current session.'
+      'Ends the current session.',
+      $ws_functions_root . 'pwg.php'
     );
 
@@ -337,5 +346,6 @@
                                    'type'=>WS_TYPE_BOOL),
         ),
-      'Retrieves a list of available tags.'
+      'Retrieves a list of available tags.',
+      $ws_functions_root . 'pwg.tags.php'
     );
 
@@ -361,5 +371,6 @@
                                 'info'=>'id, file, name, hit, rating_score, date_creation, date_available, random'),
         ), $f_params),
-      'Returns elements for the corresponding tags. Fill at least tag_id, tag_url_name or tag_name.'
+      'Returns elements for the corresponding tags. Fill at least tag_id, tag_url_name or tag_name.',
+      $ws_functions_root . 'pwg.tags.php'
     );
 
@@ -375,5 +386,5 @@
         ),
       '<b>Admin & POST only.</b> Add a chunk of a file.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -390,5 +401,5 @@
       '<b>Admin only.</b> Add or update a file for an existing photo.
 <br>pwg.images.addChunk must have been called before (maybe several times).',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true)
     );
@@ -423,5 +434,5 @@
 <br>pwg.images.addChunk must have been called before (maybe several times).
 <br>Don\'t use "thumbnail_sum" and "high_sum", these parameters are here for backward compatibility.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true)
     );
@@ -449,5 +460,5 @@
 <br>Set the form encoding to "form-data".
 <br>You can update an existing photo if you define an existing image_id.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -461,5 +472,5 @@
         ),
       '<b>Admin & POST only.</b> Deletes image(s).',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -470,5 +481,5 @@
       null,
       '<b>Admin only.</b>',
-      null,
+      $ws_functions_root . 'pwg.categories.php',
       array('admin_only'=>true)
     );
@@ -489,5 +500,7 @@
                                 'type'=>WS_TYPE_BOOL),
         ),
-      '<b>Admin only.</b> Adds an album.'
+      '<b>Admin only.</b> Adds an album.',
+      $ws_functions_root . 'pwg.categories.php',
+      array('admin_only'=>true)
     );
 
@@ -503,5 +516,5 @@
 <br><b>photo_deletion_mode</b> can be "no_delete" (may create orphan photos), "delete_orphans"
 (default mode, only deletes photos linked to no other album) or "force_delete" (delete all photos, even those linked to other albums)',
-      null,
+      $ws_functions_root . 'pwg.categories.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -517,5 +530,5 @@
       '<b>Admin & POST only.</b> Move album(s).
 <br>Set parent as 0 to move to gallery root. Only virtual categories can be moved.',
-      null,
+      $ws_functions_root . 'pwg.categories.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -529,5 +542,5 @@
         ),
       '<b>Admin & POST only.</b> Sets the representative photo for an album. The photo doesn\'t have to belong to the album.',
-      null,
+      $ws_functions_root . 'pwg.categories.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -538,5 +551,5 @@
       null,
       '<b>Admin only.</b>',
-      null,
+      $ws_functions_root . 'pwg.tags.php',
       array('admin_only'=>true)
     );
@@ -547,5 +560,5 @@
       array('name'),
       '<b>Admin only.</b> Adds a new tag.',
-      null,
+      $ws_functions_root . 'pwg.tags.php',
       array('admin_only'=>true)
     );
@@ -560,5 +573,5 @@
       '<b>Admin only.</b>  Checks existence of images.
 <br>Give <b>md5sum_list</b> if $conf[uniqueness_mode]==md5sum. Give <b>filename_list</b> if $conf[uniqueness_mode]==filename.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true)
     );
@@ -575,5 +588,5 @@
       '<b>Admin only.</b> Checks if you have updated version of your files for a given photo, the answer can be "missing", "equals" or "differs".
 <br>Don\'t use "thumbnail_sum" and "high_sum", these parameters are here for backward compatibility.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true)
     );
@@ -584,5 +597,5 @@
       null,
       '<b>Admin only.</b> Checks if Piwigo is ready for upload.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true)
     );
@@ -612,5 +625,5 @@
 (overwrite any existing value) and applies to single values properties like name/author/date_creation/comment.
 <br><b>multiple_value_mode</b> can be "append" (no change on existing values, add the new values) or "replace" and applies to multiple values properties like tag_ids/categories.',
-      null,
+      $ws_functions_root . 'pwg.images.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -625,5 +638,5 @@
         ),
       '<b>Admin & POST only.</b> Changes properties of an album.',
-      null,
+      $ws_functions_root . 'pwg.categories.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -634,5 +647,5 @@
       null,
       '<b>Admin only.</b> Gets the list of plugins with id, name, version, state and description.',
-      null,
+      $ws_functions_root . 'pwg.extensions.php',
       array('admin_only'=>true)
     );
@@ -647,5 +660,5 @@
         ),
       '<b>Admin only.</b>',
-      null,
+      $ws_functions_root . 'pwg.extensions.php',
       array('admin_only'=>true)
     );
@@ -660,5 +673,5 @@
         ),
       '<b>Admin only.</b>',
-      null,
+      $ws_functions_root . 'pwg.extensions.php',
       array('admin_only'=>true)
     );
@@ -674,5 +687,5 @@
         ),
       '<b>Webmaster only.</b>',
-      null,
+      $ws_functions_root . 'pwg.extensions.php',
       array('admin_only'=>true)
     );
@@ -691,5 +704,5 @@
       ),
       '<b>Webmaster only.</b> Ignores an extension if it needs update.',
-      null,
+      $ws_functions_root . 'pwg.extensions.php',
       array('admin_only'=>true)
     );
@@ -700,5 +713,5 @@
       null,
       '<b>Admin only.</b> Checks if piwigo or extensions are up to date.',
-      null,
+      $ws_functions_root . 'pwg.extensions.php',
       array('admin_only'=>true)
     );
@@ -721,5 +734,5 @@
         ),
       '<b>Admin only.</b> Retrieves a list of all groups. The list can be filtered.',
-      null,
+      $ws_functions_root . 'pwg.groups.php',
       array('admin_only'=>true)
     );
@@ -734,5 +747,5 @@
         ),
       '<b>Admin & POST only.</b> Creates a group and returns the new group record.',
-      null,
+      $ws_functions_root . 'pwg.groups.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -744,7 +757,8 @@
         'group_id' => array('flags'=>WS_PARAM_FORCE_ARRAY,
                             'type'=>WS_TYPE_ID),
+        'pwg_token' =>  array(),
         ),
       '<b>Admin & POST only.</b> Deletes a or more groups. Users and photos are not deleted.',
-      null,
+      $ws_functions_root . 'pwg.groups.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -760,5 +774,5 @@
         ),
       '<b>Admin & POST only.</b> Updates a group. Leave a field blank to keep the current value.',
-      null,
+      $ws_functions_root . 'pwg.groups.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -773,5 +787,5 @@
         ),
       '<b>Admin only.</b> Adds one or more users to a group.',
-      null,
+      $ws_functions_root . 'pwg.groups.php',
       array('admin_only'=>true)
     );
@@ -786,5 +800,5 @@
         ),
       '<b>Admin & POST only.</b> Removes one or more users from a group.',
-      null,
+      $ws_functions_root . 'pwg.groups.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -817,5 +831,5 @@
       '<b>Admin only.</b> Retrieves a list of all the users.
 <br>"display" controls which data are returned, "basics" stands for "username,email,status,level,groups"',
-      null,
+      $ws_functions_root . 'pwg.users.php',
       array('admin_only'=>true)
     );
@@ -832,5 +846,5 @@
         ),
       '<b>Admin & POST only.</b> Registers a new user.',
-      null,
+      $ws_functions_root . 'pwg.users.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -842,7 +856,8 @@
         'user_id' =>  array('flags'=>WS_PARAM_FORCE_ARRAY,
                             'type'=>WS_TYPE_ID),
+        'pwg_token' =>  array(),
         ),
       '<b>Admin & POST only.</b> Deletes on or more users. Photos owned by this user are not deleted.',
-      null,
+      $ws_functions_root . 'pwg.users.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -880,5 +895,5 @@
       '<b>Admin & POST only.</b> Updates a user. Leave a field blank to keep the current value.
 <br>"username", "password" and "email" are ignored if "user_id" is an array.',
-      null,
+      $ws_functions_root . 'pwg.users.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
@@ -897,5 +912,5 @@
       '<b>Admin only.</b> Returns permissions: user ids and group ids having access to each album ; this list can be filtered.
 <br>Provide only one parameter!',
-      null,
+      $ws_functions_root . 'pwg.permissions.php',
       array('admin_only'=>true)
     );
@@ -915,5 +930,5 @@
         ),
       '<b>Admin only.</b> Adds permissions to an album.',
-      null,
+      $ws_functions_root . 'pwg.permissions.php',
       array('admin_only'=>true)
     );
@@ -931,5 +946,5 @@
         ),
       '<b>Admin & POST only.</b> Removes permissions from an album.',
-      null,
+      $ws_functions_root . 'pwg.permissions.php',
       array('admin_only'=>true, 'post_only'=>true)
     );
